plan request-broker( task, cond )
{
	comm.Send( brokerId, "brokering " + id + " " + task + " " + cond );
	brokerMsg = comm.Recv( brokerId );
	if( is_agreed( brokerMsg ) ) {
		brokerMsg = comm.Recv( brokerId );
		match brokerMsg with {
			"brokering", id, "failure-no-match" -> {/* no match */ }
		|	"brokering", id, "failure-proxy" -> {/* proxy failed */ }
		|	"brokering", id, "inform-done-proxy" -> {
				result = comm.Recv( brokerId );	// task result or failure
			}
		}
	}
}


------------
// broker

plan processMsg( msg )
{
	match msg with {
		"brokering", @{id}, @{task}, @{cond} -> {
			if( can_broker?( task, cond ) ) {
				comm.Send( msg.Src, "brokering " + id + " agreed" );
				comm.Bcast( "request-from-broker " + rId + " " + task + " " + cond );
				comm1 = Environment.GetCommunicator( "brokering_comm_" + rId, this.processMsg  );
				target_agents = comm1.Gather( "belief query id" );
				if( target_agents.Length <= 0 ) comm.Send( msg.Src, "brokering " + id + " failure-no-match" );
				else comm.Send( msg.Src, "brokering " + id + " inform-done-proxy" );
				result = comm1.Gather( "belief query {brokering_id, result} as b where b.brokering_id == " + rId );
				if( is_failure( result ) comm.Send( msg.Src, "brokering " + id + " failure-brokering" );
				else comm.Send( msg.Src, "brokering " + id + " result " + result );
			} else comm.Send( msg.Src, "brokering " + id + " refused" );
		}
	}
}


-------------

// service agents
plan processMsg( msg )
{
	match msg with {
		"request-from-broker", @{rId}, @{task}, @{cond} -> {
			if( eval( cond ) == true && can_perform?( task ) ) {
				comm1 = Environment.GetCommunicator( "brokering_comm_" + rId, this.processMsg );
				task_result = perform( task );
				belief fact new {brokering_id = rId, result = task_result };
			}
		}
	}
}
