// auctioneer
plan auction()
{
	price = init_price;
	winner = -1;
	while( 1 ) {
		comm.Bcast( "dutch-auction " + id + " " + good + " " + price );
		winner = comm.Reduce( MAX_ID, "belief query {d_auction_id, price} as d where d.d_action_id == " + id );
		if( winner != -1 ) break;
		next_price = next( price );
		if( next_price < reserved_price ) break;
		price = next_price;
	}
	if( winner != -1 ) {
		comm.Send( winner, "dutch-auction-winner " + id );
	}
	for( i = 1; i <= nAgents; i++ ) {
		if( i != winner ) comm.Send( i, "dutch-auction-rejected " + id );
	}
}


// bidders
plan processMsg( msg )
{
	match msg with {
		"dutch-auction", @{id}, @{good}, @{price} -> {
			rs = belief query {d_auction_id, price} as d where d.d_auction_id == id;
			if( rs.Length > 0 ) { obj = rs[0]; obj.price = my_next_price( price ); }
			else belief fact new {d_auction_id = id, price = my_next_price( price ) };
		}
	|	"dutch-auction-winner", @{id}, @{good}, @{_price} -> {
			rs = belief query {d_auction_id, price} as d where d.d_auction_id == id;
			if( rs.Length > 0 ) {
				belief remove {d_auction_id, price} as d where d.d_auction_id == id;
				belief fact new {d_auction_id = id, price = price, the_good = good};
				comm.Send( msg.Src, "dutch-auction-accepted " + id );
			} else comm.Send( msg.Src, "dutch-auction-not-understand " + id );
		}
	|	"dutch-auction-rejected", @{id}, @{good}, @{price} -> 
			belief remove {d_auction_id, price} as d where d.d_auction_id == id;
	}
}
