// auctioneer
plan auction()
{
	price = init_price;
	winner = -1;
	while( 1 ) {
		comm.Bcast( "english-auction " + id + " " + good + " " + price );
		winnerSet = comm.Reduce( MAX_ID, "belief query {e_auction_id, price} as ea where ea.e_auction_id == " + id );
		if( winnerSet.Length <= 0 ) break;
		price = next( price );
	}
	if( winner != -1 ) {
		if( price >= reserved_price ) {
			comm.Send( winner, "english-auction-winner " + id + " " + good + " " + price );
			confirm = comm.Recv( winner );
		} else comm.Send( winner, "english-auction-rejected " + id );
	}
	for( i = 1; i <= nAgents; i++ ) {
		if( i != winner ) comm.Send( i, "english-auction-rejected " + id );
	}
}


// bidders
plan processMsg( msg )
{
	match msg with {
		"english-auction", @{id}, @{good}, @{_price} -> {
			if( can_buy?(good, price) ) {
				belief fact new {e_auction_id = id, price = _price };
			}
		}
	|	"english-auction-winner", @{id}, @{good}, @{price} -> {
			if( belief query {e_auction_id, price} as ea where ea.e_auction_id == id ) {
				belief fact new { e_auction_id = id, price = ea.price, the_good = good };
				comm.Send( msg.Src, "english-auction-confirm " + id );
			} else comm.Send( msg.Src, "english-auction-not-understand " + id );
		}
	|	"english-auction-rejected", @{id} -> {
			belief remove {e_auction_id, price} as ea where ea.e_auction_id == id;
		}
	}
}

