plan processMsg( msg )
{
	match msg with {
		"icnet-cfp", @{id}, @{highestPrice}, @{task} -> {
			if( can_perform?( task ) ) {
				my_price = eval( task );
				if( my_price > highestPrice ) my_price = INFINITY;
				belief fact new {icent_id = id, price = my_price};
			} else belief fact new {icnet_id = id, price = INFINITY}
		}
	
	|	"icnet-result", @{id}, @{accepted_price}, @{task} -> {
			if( belief query {icent_id, price} as ic where ic.icnet_id == id ) {
				result = perform( task );
				comm.Send( msg.Src, "icnet-result " + id + " " + result );
			}
		}
	}
}

-------------

plan icnet( task, acceptablePrice ) {
	bestPrice = INFINITY;
	winner_id = -1;
	while( bestPrice > acceptablePrice ) {
		comm.Bcast( "icnet-cfp " + id + " " + bestPrice + " " + task );
		proposal = comm.Reduce( MIN_ID, "belief query {icnet_id, price} as ic where ic.icnet_id == " + id );
		if( proposal.price == INFINITY ) break;
		winner_id = proposal.id;
		bestPrice = proposal.price;
	}
	if( winner_id != -1 ) { // successfully found winner
		comm.Send( winner_id, "icnet-result " + id + " " + bestPrice + " " + task );
		task_result = comm.Recv( winner_id );
	} else Console.WriteLine( "can not perform task for {0}", acceptablePrice );
}
