// Initiator
plan init_recruit( task, cond, receiverId )
{
	comm.Send( recruiterId, "recruit" + id + " proxy-request " + task + " " + cond + " " + receiverId );
	retMsg = comm.Recv( recruiterId );
	if( agreed?( retMsg ) ) {
		retMsg = comm.Recv( recruiterId );
		if(  no_match?( retMsg ) ) {
			error();
		}
	}
}


// Recruiter
plan processMsg( msg )
{
	match msg with {
		"recruit", @{id}, "proxy-request", @{task}, @{cond}, @{receiverId} -> {
			if( permitted?( task, cond, receiverId ) ) {
				comm.Send( msg.Src, "recruit " + id + " agreed" );
				comm.Bcast( "recruit request " + id + " " + task + " " + cond + " " + receiverId );
				comm1 = Environment.GetCommunicator( "recruit_comm_" + id );
				service_agents = comm1.Gather( @{belief query id} );
				if( service_agents.Length > 0 ) {
					comm.Send( receiverId, "recruit " + id + " inform-done-proxy" );
				} else comm.Send( msg.Src, "recruit " + id + " failure-no-match" );
			}
		}
	}
}

// Service agents
plan processMsg( msg )
{
	match msg with {
		"recruit", "request", @{id}, @{task}, @{cond}, @{receiverId} -> {
			if( eval( cond ) == true && can_perform?( task ) ) {
				comm1 = Environment.GetCommunicator( "recruit_comm_" + id );
				belief fact new {recruited_id = id, task_result = eval( task ) };
			}
		}
	}
}


// Designated receiver
plan processMsg( msg )
{
	match msg with {
		"recruited", @{id}, "inform-done-proxy" -> {
			comm1 = Environment.GetCommunicator( "recruit_comm_" + id );
			result_set = comm1.Gather( "belief query {recruited_id, task_result} as r where r.recruited_id == " + id );
		}
	}
}

